import {
  Offer,
  OfferCharge,
  OfferRepaymentLogic,
  OFFER_FREQUENCY_TYPE,
  OFFER_STATUS,
} from '@app/plugins/modules/product-catalogue/core/models/offer.model';
import { TableResponse } from '@app/presentation/layout/mo-tables/interfaces/table.interface';
import { CHARGE_TYPE, CHARGE_VALUE_TYPE } from '../../core/models/charge.model';
export const OFFERS: Offer[] = [
  {
    id: 'adbfad7c-16e3-4830-ac50-4f550002e78d',
    name: 'Offer-MCA 1',
    status: OFFER_STATUS.DISABLED,
    reference: '0deebd2c-22d8-458d-825f-f336ee52d864',
    product_id: '0c157338-3058-4b44-a280-e644221b44cb',
    product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
    product_name: 'Products name 1',
    number_of_installments: '10',
    downpayment: '10.0000',
    offer_value: '10',
    is_new: true,
    minimum_loan_amount: '1.0000000000',
    maximum_loan_amount: '100.0000000000',
    created_at: new Date('2017-07-12 21:56:59'),
    updated_at: new Date('2017-07-12 21:56:59'),
  },
  {
    id: '700ce1ae-c840-4de9-a61a-13050fdd8dff',
    name: 'Offer-MCA 2',
    status: OFFER_STATUS.DRAFT,
    reference: '69fcf7a4-1160-400e-a3b1-bae98b9bb925',
    product_id: '0c157338-3058-4b44-a280-e644221b44cb',
    product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
    product_name: 'Products name 2',
    number_of_installments: '10',
    downpayment: '10.0000',
    offer_value: '10',
    is_new: true,
    minimum_loan_amount: '1.0000000000',
    maximum_loan_amount: '100.0000000000',
    created_at: new Date('2016-07-05 22:00:55'),
    updated_at: new Date('2016-07-05 22:00:55'),
  },
  {
    id: '384d755b-207f-45d4-b633-636b76360862',
    name: 'Offer-MCA 3',
    status: OFFER_STATUS.ENABLED,
    reference: '6f222893-7219-4123-a8d0-118ecbaf092d',
    product_id: '0c157338-3058-4b44-a280-e644221b44cb',
    product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
    product_name: 'Products name 3',
    number_of_installments: '10',
    downpayment: '10.0000',
    offer_value: '10',
    is_new: true,
    minimum_loan_amount: '1.0000000000',
    maximum_loan_amount: '100.0000000000',
    created_at: new Date('2015-07-08 15:43:26'),
    updated_at: new Date('2015-07-08 15:43:26'),
  },
  {
    id: '01ecbee0-8b31-48b6-b712-78c54783899f',
    name: 'Offer-MCA 4',
    status: OFFER_STATUS.DISABLED,
    reference: '035060e6-5801-48d3-bb97-019504b873fd',
    product_id: '0c157338-3058-4b44-a280-e644221b44cb',
    product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
    product_name: 'Products name 4',
    number_of_installments: '10',
    downpayment: '10.0000',
    offer_value: '20',
    is_new: true,
    minimum_loan_amount: '1.0000000000',
    maximum_loan_amount: '100.0000000000',
    created_at: new Date('2014-07-05 17:05:56'),
    updated_at: new Date('2014-07-05 17:05:56'),
  },
  {
    id: 'a1dbfad7c-16e3-4830-ac50-4f550002e78d',
    name: 'Offer-MCA 5',
    status: OFFER_STATUS.DISABLED,
    reference: '0deebd2c-22d8-458d-825f-f336ee52d864',
    product_id: '0c157338-3058-4b44-a280-e644221b44cb',
    product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
    product_name: 'Products name 5',
    number_of_installments: '10',
    downpayment: '10.0000',
    offer_value: '20',
    is_new: false,
    minimum_loan_amount: '1.0000000000',
    maximum_loan_amount: '100.0000000000',
    created_at: new Date('2013-07-12 21:56:59'),
    updated_at: new Date('2013-07-12 21:56:59'),
  },
  {
    id: '7020ce1ae-c840-4de9-a61a-13050fdd8dff',
    name: 'Offer-MCA 6',
    status: OFFER_STATUS.DRAFT,
    reference: '69fcf7a4-1160-400e-a3b1-bae98b9bb925',
    product_id: '0c157338-3058-4b44-a280-e644221b44cb',
    product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
    product_name: 'Products name 6',
    number_of_installments: '10',
    downpayment: '10.0000',
    offer_value: '20',
    is_new: false,
    minimum_loan_amount: '1.0000000000',
    maximum_loan_amount: '100.0000000000',
    created_at: new Date('2012-07-05 22:00:55'),
    updated_at: new Date('2012-07-05 22:00:55'),
  },
  {
    id: '3384d755b-207f-45d4-b633-636b76360862',
    name: 'Offer-MCA 7',
    status: OFFER_STATUS.ENABLED,
    reference: '6f222893-7219-4123-a8d0-118ecbaf092d',
    product_id: '0c157338-3058-4b44-a280-e644221b44cb',
    product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
    product_name: 'Products name 7',
    number_of_installments: '10',
    downpayment: '10.0000',
    offer_value: '30',
    is_new: false,
    minimum_loan_amount: '1.0000000000',
    maximum_loan_amount: '100.0000000000',
    created_at: new Date('2011-07-08 15:43:26'),
    updated_at: new Date('2011-07-08 15:43:26'),
  },
  {
    id: '014ecbee0-8b31-48b6-b712-78c54783899f',
    name: 'Offer-MCA 8',
    status: OFFER_STATUS.DISABLED,
    reference: '035060e6-5801-48d3-bb97-019504b873fd',
    product_id: '0c157338-3058-4b44-a280-e644221b44cb',
    product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
    product_name: 'Products name 8',
    number_of_installments: '10',
    downpayment: '10.0000',
    offer_value: '30',
    is_new: false,
    minimum_loan_amount: '1.0000000000',
    maximum_loan_amount: '100.0000000000',
    created_at: new Date('2010-07-05 17:05:56'),
    updated_at: new Date('2010-07-05 17:05:56'),
  },
];

export const OFFERS_TABLE: TableResponse<Offer> = {
  results: [
    {
      id: 'adbfad7c-16e3-4830-ac50-4f550002e78d',
      name: 'Offer-MCA',
      status: OFFER_STATUS.DISABLED,
      reference: '0deebd2c-22d8-458d-825f-f336ee52d864',
      product_id: '0c157338-3058-4b44-a280-e644221b44cb',
      product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
      product_name: 'Products name',
      number_of_installments: '10',
      downpayment: '10.0000',
      minimum_loan_amount: '1.0000000000',
      maximum_loan_amount: '100.0000000000',
      created_at: new Date('2022-07-12 21:56:59'),
      updated_at: new Date('2022-07-12 21:56:59'),
    },
    {
      id: '700ce1ae-c840-4de9-a61a-13050fdd8dff',
      name: 'Offer-MCA',
      status: OFFER_STATUS.DRAFT,
      reference: '69fcf7a4-1160-400e-a3b1-bae98b9bb925',
      product_id: '0c157338-3058-4b44-a280-e644221b44cb',
      product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
      product_name: 'Products name',
      number_of_installments: '10',
      downpayment: '10.0000',
      minimum_loan_amount: '1.0000000000',
      maximum_loan_amount: '100.0000000000',
      created_at: new Date('2022-07-05 22:00:55'),
      updated_at: new Date('2022-07-05 22:00:55'),
    },
    {
      id: '384d755b-207f-45d4-b633-636b76360862',
      name: 'Offer-MCA',
      status: OFFER_STATUS.ENABLED,
      reference: '6f222893-7219-4123-a8d0-118ecbaf092d',
      product_id: '0c157338-3058-4b44-a280-e644221b44cb',
      product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
      product_name: 'Products name',
      number_of_installments: '10',
      downpayment: '10.0000',
      minimum_loan_amount: '1.0000000000',
      maximum_loan_amount: '100.0000000000',
      created_at: new Date('2022-07-08 15:43:26'),
      updated_at: new Date('2022-07-08 15:43:26'),
    },
    {
      id: '01ecbee0-8b31-48b6-b712-78c54783899f',
      name: 'Offer-MCA',
      status: OFFER_STATUS.DISABLED,
      reference: '035060e6-5801-48d3-bb97-019504b873fd',
      product_id: '0c157338-3058-4b44-a280-e644221b44cb',
      product_reference: 'd1a727f3-aca1-4b90-9f0c-ebe0c9c45c46',
      product_name: 'Products name',
      number_of_installments: '10',
      downpayment: '10.0000',
      minimum_loan_amount: '1.0000000000',
      maximum_loan_amount: '100.0000000000',
      created_at: new Date('2022-07-05 17:05:56'),
      updated_at: new Date('2022-07-05 17:05:56'),
    },
  ],
  filtered: 4,
  count: 8,
};

export const OFFER: Offer = {
  id: 'a4257122-9608-41a0-b8ea-cef63e0e7833',
  name: 'Dr. Candace Craig DDS',
  created_at: new Date('2022-10-19T17:49:38.689994Z'),
  updated_at: new Date('2022-10-19T17:49:38.689999Z'),
  status: OFFER_STATUS.DISABLED,
  reference: 'aNapBnrBVsJHQkNtqwlK',
  product_id: '0c0b8ba0-415d-4ec9-b00d-0fb16877c9db',
  product_reference: 'RQborgDpiFVFTbXQbTBe',
  downpayment: '10.0000',
  minimum_loan_amount: '1.0000000000',
  maximum_loan_amount: '100.0000000000',
  maximum_number_active_loans: 28934,
};

export const OFFER_REPAYMENT_LOGIC: OfferRepaymentLogic = {
  id: '70b77bb6-fae6-49dc-9ec1-35b16c44aafe',
  reference: 'qsiEztgJgdtxUSBqxUrY',
  repayment_type: 'installment',
  repayment_frequency_type: OFFER_FREQUENCY_TYPE.WEEKLY,
  repayment_frequency_day_type: 'calendar',
  repayment_frequency_day: 30,
  repayment_frequency_week_day: 'Tuesday',
  installments_number: 1,
  loan_term_value: '10.0000000000',
  loan_term_periodicity: OFFER_FREQUENCY_TYPE.WEEKLY,
  repayment_installment_type: 'variable',
  repayment_missed_payment_logic: 'accumulative',
  repayment_grace_days: 20,
};

export const OFFER_CHARGES: OfferCharge[] = [
  {
    id: '905c0a78-a74b-424f-b9d7-89b1142f4f42',
    reference: '4d9925fe-503a-4f46-b372-22daec6c9384',
    name: 'cost',
    type: CHARGE_TYPE.COST,
    priority: 3,
    value_detail_value: '100.0000000000',
    value_detail_type: CHARGE_VALUE_TYPE.FIXED,
    value_detail_base: null,
    tax_value: null,
    tax_type: null,
    tax_name: null,
    grace_period_frequency_type: null,
    grace_period_frequency_week_day: null,
    installment_frequency_type: 'unique',
    installment_frequency_week_day: null,
    installment_frequency_day: null,
    grace_period_frequency_quantity: null,
  },
  {
    id: '2baaa901-a5ca-42d4-809b-abe611cc237f',
    reference: 'c16a0e11-a736-471c-9202-7f556aa0234c',
    name: 'default_interest',
    type: CHARGE_TYPE.DEFAULT_INTEREST,
    priority: 5,
    value_detail_value: '0.1854971831',
    value_detail_type: CHARGE_VALUE_TYPE.PERCENTAGE,
    value_detail_base: 'total',
    tax_value: '19.0000000000',
    tax_type: CHARGE_VALUE_TYPE.PERCENTAGE,
    tax_name: 'capital',
    grace_period_frequency_type: OFFER_FREQUENCY_TYPE.DAILY,
    grace_period_frequency_week_day: 'Monday',
    installment_frequency_type: 'weekly',
    installment_frequency_week_day: 'Monday',
    installment_frequency_day: null,
    grace_period_frequency_quantity: 1,
  },
  {
    id: '2baaa901-a5ca-42d4-809b-abe611cc237f',
    reference: 'c16a0e11-a736-471c-9202-7f556aa0234c',
    name: 'interest',
    type: CHARGE_TYPE.INTEREST,
    priority: 5,
    value_detail_value: '0.1854971831',
    value_detail_type: CHARGE_VALUE_TYPE.PERCENTAGE,
    value_detail_base: 'total',
    tax_value: '19.0000000000',
    tax_type: CHARGE_VALUE_TYPE.PERCENTAGE,
    tax_name: 'capital',
    grace_period_frequency_type: OFFER_FREQUENCY_TYPE.WEEKLY,
    grace_period_frequency_week_day: 'Monday',
    installment_frequency_type: 'weekly',
    installment_frequency_week_day: 'Monday',
    installment_frequency_day: null,
    grace_period_frequency_quantity: 1,
  },
  {
    id: 'd30a2dff-1ac2-4e0d-b56d-f44aa0edf815',
    reference: 'b29552f8-c6be-4456-97e8-c3768b57ad6a',
    name: 'capital',
    type: CHARGE_TYPE.CAPITAL,
    priority: 1,
    value_detail_value: '100.0000000000',
    value_detail_type: CHARGE_VALUE_TYPE.PERCENTAGE,
    value_detail_base: 'base',
    tax_value: null,
    tax_type: null,
    tax_name: null,
    grace_period_frequency_type: null,
    grace_period_frequency_week_day: null,
    installment_frequency_type: 'unique',
    installment_frequency_week_day: null,
    installment_frequency_day: null,
    grace_period_frequency_quantity: null,
  },
  {
    id: 'c02dfd75-7c87-41db-9f60-bc1526a573cf',
    reference: '9b756456-43ff-4d7d-9f63-f4a10d4505ba',
    name: 'collection_cost',
    type: CHARGE_TYPE.COLLECTION_COST,
    priority: 4,
    value_detail_value: '20.0000000000',
    value_detail_type: CHARGE_VALUE_TYPE.PERCENTAGE,
    value_detail_base: 'capital',
    tax_value: null,
    tax_type: null,
    tax_name: null,
    grace_period_frequency_type: null,
    grace_period_frequency_week_day: null,
    installment_frequency_type: 'unique',
    installment_frequency_week_day: null,
    installment_frequency_day: null,
    grace_period_frequency_quantity: null,
  },
];
